(set-logic AUFLIA)

(declare-fun natp (Int) Bool)
(assert
  (forall ((?n Int)) (= (natp ?n) (<= 0 ?n))))

(declare-fun clint0vl (Int Int) Bool)
(assert
  (forall ((?i Int) (?n Int))
    (= (clint0vl ?i ?n) (and (<= 0 ?i) (<= ?i ?n)))))

(declare-fun hoint0vl (Int Int) Bool)
(assert
  (forall ((?i Int) (?n Int))
    (= (hoint0vl ?i ?n) (and (<= 0 ?i) (< ?i ?n)))))

(declare-fun fun1p ((Array Int Int) Int Int) Bool)
(assert
  (forall ((?f (Array Int Int)) (?m Int) (?n Int))
    (= (fun1p ?f ?m ?n)
       (forall ((?i Int))
          (=> (clint0vl ?i ?m) (hoint0vl (select ?f ?i) ?n))))))

(declare-fun fun2p ((Array Int Int) Int Int) Bool)
(assert
  (forall ((?f (Array Int Int)) (?m Int) (?n Int))
    (= (fun2p ?f ?m ?n)
       (forall ((?i Int))
          (=> (hoint0vl ?i ?m) (hoint0vl (select ?f ?i) ?n))))))

(declare-fun ninj1p ((Array Int Int) Int) Bool)
(assert
  (forall ((?f (Array Int Int)) (?n Int))
    (= (ninj1p ?f ?n)
       (exists ((?i Int) (?j Int))
         (and (hoint0vl ?i ?j)
	      (<= ?j ?n)
	      (= (select ?f ?i) (select ?f ?j)))))))

(declare-fun inj2p ((Array Int Int) Int) Bool)
(assert
  (forall ((?f (Array Int Int)) (?n Int))
    (= (inj2p ?f ?n)
       (forall ((?i Int) (?j Int))
         (=> (and (hoint0vl ?i ?n)
	          (hoint0vl ?j ?n)
		  (= (select ?f ?i) (select ?f ?j)))
             (= ?i ?j))))))

(declare-fun surj2p ((Array Int Int) Int Int) Bool)
(assert
  (forall ((?f (Array Int Int)) (?m Int) (?n Int))
    (= (surj2p ?f ?m ?n)
       (forall ((?j Int))
         (=> (hoint0vl ?j ?n)
	     (exists ((?i Int))
	       (and (hoint0vl ?i ?m)
	            (= (select ?f ?i) ?j))))))))

(assert
  (forall
   ((?n Int))
   (=> (natp ?n)
        (forall
 	 ((?f (Array Int Int)))
          (=> (fun2p ?f ?n ?n)
	   (=> (inj2p ?f ?n)
	       (forall ((?j Int))
                (=> (hoint0vl ?j ?n)
    (=> (forall
         ((?g (Array Int Int)))
          (=> (fun1p ?g ?n ?n)
	      (ninj1p ?g ?n)))
        (exists ((?i Int))
           (and (hoint0vl ?i ?n)
                (= (select ?f ?i) ?j))))))))))))

(assert
 (not
  (forall
   ((?n Int))
   (=> (natp ?n)
    (=> (forall
         ((?f (Array Int Int)))
          (=> (fun1p ?f ?n ?n)
	      (ninj1p ?f ?n)))
        (forall
 	 ((?f (Array Int Int)))
          (=> (fun2p ?f ?n ?n)
	   (=> (inj2p ?f ?n)
	       (forall ((?j Int))
                (=> (hoint0vl ?j ?n)
	         (exists ((?i Int))
	           (and (hoint0vl ?i ?n)
	                (= (select ?f ?i) ?j)))))))))))))
				       
(check-sat)
